#ifndef _SAFESPOOL_H_
#define _SAFESPOOL_H_

#include <stddef.h>

namespace SafeSpool {

struct Spooler_impl;

enum stop_action_t { stop_now, stop_soon, stop_whenever };

class Spooler {
	Spooler_impl *impl;
public:
	Spooler(const char *basename, size_t cycle_size);
	void stop(stop_action_t stop_action=stop_now);
	virtual ~Spooler();
	
	struct Item {
		const void *buf;
		size_t sz;
	};
	
	bool queue(const void *buf, size_t sz) {
		Item i;
		i.buf = buf;
		i.sz = sz;
		return queueBatch(&i,1);
	}
	
	bool queueBatch(const Item *item, int items);
	
	virtual bool forwardBatch(const Item *item, int items) =0;
};

} //namespace

#endif
